from collections import defaultdict, deque
 
n, m, k = map(int, input().split())  
 
roads = []
for _ in range(m):
    a, b = map(int, input().split())
    roads.append((a, b))
 
guards = []
for _ in range(k):
    pi, hi = map(int, input().split())
    guards.append((pi, hi))
 
 
graph = defaultdict(list)
for a, b in roads:
    graph[a].append(b)
    graph[b].append(a)
 
 
guarded = [False] * (n + 1)
 
 
for pi, hi in guards:
    queue = deque([(pi, 0)])
    visited = set()
    while queue:
        current, distance = queue.popleft()
        if current in visited or distance > hi:
            continue
        visited.add(current)
        guarded[current] = True
        for neighbor in graph[current]:
            if neighbor not in visited:
                queue.append((neighbor, distance + 1))
 
result = [i for i in range(1, n + 1) if guarded[i]]
 
print(len(result))
print(" ".join(map(str, result)))